"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

exports.__esModule = true;
exports.withLayout = withLayout;
exports.default = void 0;

var _map = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/map"));

var _react = _interopRequireDefault(require("react"));

var layoutMap = new _map.default();

function withLayout() {
  for (var _len = arguments.length, layout = new Array(_len), _key = 0; _key < _len; _key++) {
    layout[_key] = arguments[_key];
  }

  return function (page) {
    var layouts = layoutMap.get(page);

    if (layouts) {
      layouts.push(...layout);
    } else {
      layoutMap.set(page, layout);
    }

    return page;
  };
}

var Layout = (_ref) => {
  var {
    component: Component,
    pageProps
  } = _ref;
  var layouts = layoutMap.get(Component);

  var children = _react.default.createElement(Component, pageProps);

  if (layouts && layouts.length) {
    return layouts.reduce((children, ComponentLayout) => _react.default.createElement(ComponentLayout, null, children), children);
  }

  return children;
};

var _default = Layout;
exports.default = _default;